--- vim_source/src/misc1.c	2013-09-10 14:35:06.000000000 +0100
+++ vim_source_patched/src/misc1.c	2013-09-10 15:35:30.000000000 +0100
@@ -14,6 +14,11 @@
 #include "vim.h"
 #include "version.h"
 
+#include <unistd.h>
+#include <libgen.h>
+#include <string.h>
+#include <stdlib.h>
+
 static char_u *vim_version_dir __ARGS((char_u *vimdir));
 static char_u *remove_tail __ARGS((char_u *p, char_u *pend, char_u *name));
 #if defined(FEAT_CMDL_COMPL)
@@ -4181,6 +4186,22 @@
     if (!vimruntime && STRCMP(name, "VIM") != 0)
 	return NULL;
 
+    if (vimruntime) {
+        char curr_exe_path[1024];
+        ssize_t len;
+        if ((len = readlink("/proc/self/exe", curr_exe_path, sizeof(curr_exe_path)-1)) != -1) {
+            curr_exe_path[len] = '\0';
+            static char runtime_path[2048];
+            memset(runtime_path,0,2048);
+            char* top_dir = dirname(dirname(curr_exe_path));
+            strcpy(runtime_path,top_dir);
+            strcpy(runtime_path+strlen(top_dir),"/runtime");
+
+            default_vimruntime_dir = runtime_path;
+            p = runtime_path;
+        }
+    }
+
     /*
      * When expanding $VIMRUNTIME fails, try using $VIM/vim<version> or $VIM.
      * Don't do this when default_vimruntime_dir is non-empty.
